#ifndef __winMathFun_h__
#define __winMathFun_h__
#include "winExeOpe.h"

tokenData fltDT(tokenData X){
	tokenData R; R.type=FLT;
	if     (X.type==DEC) R.v.DBL=(double)X.v.INT;
	else if(X.type==FLT) R.v.DBL = X.v.DBL;
	else                 R.v.DBL = 0;
	return R;
}
tokenData mathFun(double (*fn)(double X), tokenData V){
	tokenData R, XX; R.type=FLT ;XX=fltDT(V); R.v.DBL=fn(V.v.DBL);
	return R;
}
tokenData sin (tokenData X){ return mathFun(sin , X);}
tokenData cos (tokenData X){ return mathFun(cos , X);}
tokenData tan (tokenData X){ return mathFun(tan , X);}
tokenData asin(tokenData X){ return mathFun(asin, X);}
tokenData acos(tokenData X){ return mathFun(acos, X);}
tokenData atan(tokenData X){ return mathFun(atan, X);}
tokenData sinh(tokenData X){ return mathFun(sinh, X);}
tokenData cosh(tokenData X){ return mathFun(cosh, X);}
tokenData tanh(tokenData X){ return mathFun(tanh, X);}
tokenData exp (tokenData X){ return mathFun(exp , X);}
tokenData log (tokenData X){ return mathFun(log , X);}
tokenData sqrt(tokenData X){ return mathFun(sqrt, X);}

#endif